<?php

namespace FiloBlu\Eva\Observer;

use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;

class LayoutLoadBeforeObserver implements ObserverInterface {

    public $_helper;

    public function __construct(\FiloBlu\Eva\Helper\Data $helper) {
        $this->_helper = $helper;
    }

    /**
     * @param Observer $observer
     * @return void
     */
    public function execute(Observer $observer) {
        $layout = $observer->getData('layout');
        $currentLayoutHandles = $layout->getUpdate()->getHandles();

        # add transparent class to header if setting is enabled
        if (in_array("default", $currentLayoutHandles) && $this->_helper->getConfig("eva_layout_section/eva_header/eva_transparent_header")) {
            if ($this->_helper->getConfig("eva_layout_section/eva_header/eva_header_type") == 1) {
                $layout->getUpdate()->addUpdate('<referenceContainer name="header.container" htmlClass="page-header transparent"/>');
            } elseif ($this->_helper->getConfig("eva_layout_section/eva_header/eva_header_type") == 2) {
                $layout->getUpdate()->addUpdate('<referenceContainer name="header.container" htmlClass="page-header transparent left-logo"/>');
            }

        } elseif (in_array("default", $currentLayoutHandles) && !$this->_helper->getConfig("eva_layout_section/eva_header/eva_transparent_header")) {
           if ($this->_helper->getConfig("eva_layout_section/eva_header/eva_header_type") == 2) {
                $layout->getUpdate()->addUpdate('<referenceContainer name="header.container" htmlClass="page-header left-logo"/>');
           }
        }
        # set instruction for header type "normal"
        if (in_array("default", $currentLayoutHandles) && $this->_helper->getConfig("eva_layout_section/eva_header/eva_header_type") == 1) {
            $layout->getUpdate()->addUpdate('
                <move element="logo" destination="logo.container" before="-" />
                <move element="filoblu_extamastygeoipredirect_popup" destination="header.left.menu" as="geoip" />
                <move element="store_language" destination="header.left.menu" as="store.language" />
                <move element="currency" destination="header.left.menu" as="store.currency" />
            ');
        }

        # set instruction for "logo left" header type
        if (in_array("default", $currentLayoutHandles) && $this->_helper->getConfig("eva_layout_section/eva_header/eva_header_type") == 2) {
            $layout->getUpdate()->addUpdate('                
                <move element="logo" destination="header.left.menu" before="-"/>
                <move element="main.menu" destination="logo.container" after="-"/>
                <move element="filoblu_extamastygeoipredirect_popup" destination="footer.user.menu" as="geoip" />
                <move element="currency" destination="footer.user.menu" as="store.currency" />
                <move element="store_language" destination="footer.user.menu" as="store.language" />
                <referenceContainer name="header-wrapper" htmlClass="header content left-logo"/>
            ');
        }

        #set instructions for "category top filters"
        if (in_array("catalog_category_view_type_layered", $currentLayoutHandles) && $this->_helper->getConfig("eva_category_section/eva_category/eva_filters_position") == 2) {
            $layout->getUpdate()->addUpdate('                
                <body><attribute name="class" value="top-filters"/></body>
            ');
        }

        if (in_array("catalogsearch_result_index", $currentLayoutHandles) && $this->_helper->getConfig("eva_category_section/eva_category/eva_filters_position") == 2) {
            $layout->getUpdate()->addUpdate('                
                <body><attribute name="class" value="top-filters"/></body>
            ');
        }
    }

}